<template>
   <base-layout>
   <h1 class="mt-4">Add an Event</h1>
      <ol class="breadcrumb mb-4">
        
    </ol>
    <hr>
    <ol class="breadcrumb mb-4">
        
    </ol>
    <div class="card mb-4">
        <div class="card-header">
          <i class="fas fa-columns me-1"></i>
            Events
      </div>
      <div class="card-body">
        <div class="container">
          <div class="row">
            <div class="col-md-offset-1 col-md-10">
              <div class="panel">
                <div class="panel-heading">
                  <div class="row">
                    <div class="col-sm-12 col-xs-12">
    
                      <!-- Modal --> <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
       
    </section>

    <section class="content">

        <div class="row">
            <!-- left column -->
            <div class="col-md-8">
                <!-- general form elements -->



                <div class="box box-primary">
                    
                    <form :model="eventRequest" id="addUser"  >
                        <div class="box-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="fname">Name</label>
                                        <input type="text" v-model="eventRequest.name" class="form-control required" required  id="fname" name="fname" maxlength="128">
                                    </div>

                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="email">Location</label>
                                        <input type="text" v-model="eventRequest.location" class="form-control required email" id="email" 
                                            maxlength="128">
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="password">Description</label>
                                        <textarea  id="" v-model="eventRequest.description" cols="30" rows="3" class="form-control required"></textarea>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="cpassword">Start Date</label>
                                        <input type="date" v-model="eventRequest.start_date" class="form-control required equalTo" id="cpassword"  >
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="mobile">End Date</label>
                                        <input type="date" v-model="eventRequest.end_date" class="form-control required digits" id="mobile"  
                                            maxlength="10">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="role">Start time</label>
                                        <input type="time" v-model="eventRequest.start_time" class="form-control required digits" id="mobile"  
                                            maxlength="10">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="role">End time</label>
                                        <input type="time" v-model="eventRequest.end_time" class="form-control required digits" id="mobile"  
                                            maxlength="10">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label for="role">Add Members</label>
                                        <select class="form-control required" id="role" >
                                            <option value="0">Select Members</option>
                                            <option value="">guy@gmail.com</option>
                                            <option value="">hen@gmail.com</option>
                                         
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        &nbsp;

                        <div class="box-footer">
                            <button type="submit"  @click.prevent="generate" class="btn btn-success">Save</button>
                            &nbsp;
                            <button type="reset" class="btn btn-success">Cancel</button>
                        </div>
                    </form>
                </div>
            </div>
           
            </div>
        
    </section>
</div>
                      
                    </div>
    
                  </div>
                </div>
                

              </div>
            </div>
          </div>
        </div>
      </div>
      </div>
  
    </base-layout>
</template>

<script>
import { POST_EVENT } from '../api/api.js';
import { pki, util, random, cipher } from "node-forge";
import { POST_KEY } from "../api/api.js"
export default{
    data(){
        return{
            eventRequest:{
                name:"",
                description:"",
                start_date:"",
                end_date:"",
                start_time:"",
                end_time:"",
                location:""
            },
            encryptedInfo:{
                name:"",
                description:"",
                start_date:"",
                end_date:"",
                start_time:"",
                end_time:"",
                location:"",
                id:0
            },
            apiresponse:{
        success: false,
        message: '',
      },
      encryptedKey:"",
            handshakeIdd:"",
            keypair:"",
            keyRequest:{
                publicKey:"",
            },
            sharedKey:"",
            Response:"",
            decrypted:""
        }
    },
    methods:{
        addSubmit: function() {
    
            POST_EVENT(this.eventRequest)
                .then(res => {
                this.$router.push({ path: "/event" });
                  this.apiresponse = res;
                  console.log("message: " + this.apiresponse.message);
                  
                })
                .catch(e => {
                  console.log(e);
                });
            },

            generate: async function(){
            await pki.rsa.generateKeyPair({bits: 2048, workers: 2}, (err, k) =>{
                this.keypair = k
            });
            this.keyRequest.publicKey = pki.publicKeyToPem(this.keypair.publicKey);
            console.log(this.keyRequest.publicKey);
            ///sending the public key to server and save the encyrpted shared key
            POST_KEY(this.keyRequest)
            .then((res) => {
                console.log(res);
                this.response = res;
                this.encryptedKey = this.response.encryptedKey;
                this.handshakeIdd = this.response.handshakeId;
                this.sharedKey = util.decode64(this.encryptedKey);
                this.decrypted = this.keypair.privateKey.decrypt(this.sharedKey);
                //console.log(this.decrypted);
                let iv = random.getBytesSync(16);
                const encryption = cipher.createCipher("AES-CBC", this.decrypted);
                encryption.start({ iv });
                encryption.update(util.createBuffer(this.eventRequest.name, "utf8"));
                encryption.finish();
                this.encryptedInfo.name = util.encode64(iv + encryption.output.data);
                this.encryptedInfo.id = this.handshakeIdd;
                this.encryptedInfo.description = this.eventRequest.description;
                this.encryptedInfo.location = this.eventRequest.location;
                this.encryptedInfo.end_date = this.eventRequest.end_date;
                this.encryptedInfo.end_time = this.eventRequest.end_time;
                this.encryptedInfo.start_date = this.eventRequest.start_date;
                this.encryptedInfo.start_time = this.eventRequest.start_time;
                console.log(this.encryptedInfo.end_date);
                //posting the event
                
                POST_EVENT(this.encryptedInfo)
                .then(res => {
                this.$router.push({ path: "/event" });
                  this.apiresponse = res;
                  console.log("message: " + this.apiresponse.message);
                  
                })
                .catch(e => {
                    
                  console.log(e);
                });

                // POST_TASK(this.encryptedInfo).then((res) => {
                //     console.log(res);
                // }).catch(e => {
                //     console.log(e);
                // });
                // console.log(this.info.name);
                // console.log(this.encryptedInfo.name);
                // console.log(this.encryptedInfo.id);

                }).catch(e => {
                console.log(e);
                
                }); 
                

        },
            

        }
}
</script>